#ifndef _inbound_h
#define _inbound_h

/*
 * Checks if the file is already exists in our inbound. !0=ok, 0=failed.
 */
int inb_test (char *filename, unsigned long size, time_t t, int secure);

/*
 * Open a partial file in the inbound directory for appending.
 * Creates it if the file does not exists
 */
FILE *inb_fopen (char *netname, unsigned long size, time_t t,
		  FTN_ADDR *from, int secure);

/*
 * File is complete, rename it to it's realname. 1=ok, 0=failed.
 */
int inb_done (char *netname, unsigned long size, time_t t,
	       FTN_ADDR *from, int secure);

#endif
